/* tzf31d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    int iter;
} zf31rr_;

#define zf31rr_1 zf31rr_

int main(void)
{
    /* Initialized data */

    static double root[3] = { 1.,1.,1. };

    /* Local variables */
    static double beta[3];
    extern int zf31d_c(U_fp, double *, int *, double *, double *,
                       int *, double *, double *, int *, int *);
    static double epsf;
    static int ierr;
    static double epsx;
    static int n, nlead[3];
    static double alpha[9]  /* was [3][3] */;
    static int itmax;
    extern int fun_c();

    n = 3;
    epsx = 1e-5;
    epsf = 1e-5;
    itmax = 30;
    zf31d_c((U_fp)fun_c, root, &n, &epsx, &epsf, &itmax, alpha, beta, nlead,
            &ierr);

    printf("\n %15.6e %15.6e %15.6e \n", root[0], root[1], root[2]);
    printf("\n %5i \n", zf31rr_1.iter);
    printf("\n %5i \n", ierr);
    return 0;
} /* main */

int fun_c(double *x, double *alpha, double *beta)
{
    /* System generated locals */
    double d__1;

    /* Builtin functions */
    double exp(double), sin(double), cos(double);

#define alpha_ref(a_1,a_2) alpha[(a_2)*3 + a_1]

    /* Parameter adjustments */
    --beta;
    alpha -= 4;
    --x;

    /* Function Body */
/* Computing 2nd power */
    d__1 = x[2] + x[3];
    beta[1] = -(x[1] + exp(x[1] - 1) + d__1 * d__1 - 27);
/* Computing 2nd power */
    d__1 = x[3];
    beta[2] = -(x[1] * exp(x[2] - 2) + d__1 * d__1 - 10);
/* Computing 2nd power */
    d__1 = x[2];
    beta[3] = -(x[3] + sin(x[2] - 2) + d__1 * d__1 - 7);
    alpha_ref(1, 1) = exp(x[1] - 1) + 1;
    alpha_ref(1, 2) = (x[2] + x[3]) * 2;
    alpha_ref(1, 3) = (x[2] + x[3]) * 2;
    alpha_ref(2, 1) = exp(x[2] - 2);
    alpha_ref(2, 2) = x[1] * exp(x[2] - 2);
    alpha_ref(2, 3) = x[3] * 2;
    alpha_ref(3, 1) = 0.;
    alpha_ref(3, 2) = cos(x[2] - 2) + x[2] * 2;
    alpha_ref(3, 3) = 1.;
    return 0;
} /* fun_c */

#undef alpha_ref
